my_app/app/base/models.py
# -*- encoding: utf-8 -*-
"""
Copyright (c) 2019 - present AppSeed.us
"""

my_app/app/base/forms.py
# -*- encoding: utf-8 -*-
"""
Copyright (c) 2019 - present AppSeed.us
"""

from flask_wtf import FlaskForm
from wtforms import TextField, PasswordField
from wtforms.validators import Email, DataRequired

## login

class LoginForm(FlaskForm):
    email = TextField('email', id='email_login'   , validators=[DataRequired(), Email()])
    password = PasswordField('Password', id='pwd_login'        , validators=[DataRequired()])

my_app/app/base/__init__.py
# -*- encoding: utf-8 -*-
"""
Copyright (c) 2019 - present AppSeed.us
"""

from flask import Blueprint

blueprint = Blueprint(
    'base_blueprint',
    __name__,
    url_prefix='',
    template_folder='templates',
    static_folder='static'
)

my_app/app/base/routes.py
from flask import render_template, redirect, request, url_for, flash, session

from app import tryton
from app.base import blueprint
from app.base.forms import LoginForm
import app.base.models 

from functools import wraps

WebUser = tryton.pool.get('web.user')
Session = tryton.pool.get('web.user.session')

def login_required(func):
    @wraps(func)
    def wrapper(*args, **kwargs):
        session_key = None
        if 'session_key' in session:
            session_key = session['session_key']
        user = Session.get_user(session_key)
        if not user:
            return redirect(url_for('login', next=request.path))
        return func(*args, **kwargs)
    return wrapper

@blueprint.route('/')
def route_default():
    return redirect(url_for('base_blueprint.login'))

## Login

@blueprint.route('/login', methods=['GET', 'POST'])
@tryton.transaction()
def login():
    login_form = LoginForm(request.form)
    if 'login' in request.form:
        #request.method == 'POST' and login_form.validate_on_submit():
        try:
            webuser = WebUser.authenticate(login_form.email.data, login_form.password.data)
            session['identified'] = False
            if webuser:
                session['session_key'] = WebUser.new_session(webuser)
                session['identified'] = True
                return redirect(url_for('base_blueprint.route_default'))
            flash('Verifique sus credenciales', 'error')
            return render_template( 'accounts/login.html', msg='Correo electrónico o contraseña incorrecta', form=login_form)
        except:
            return 'Demasiados intentos de ingreso o algun otro error. Espere un momento y vuelvalo a intentar'
    return render_template('accounts/login.html', form=login_form)

# Logout
@login_required
@blueprint.route('/logout')
@tryton.transaction(readonly=False)
def logout():
    if session['session_key']:
        Session.delete(Session.search(
                ('key', '=', session['session_key']),
                ))
        session.pop('session_key', None)
        session.pop('identified', None)
        flash("Se ha desconectado tu sesión", 'success')
    return redirect(url_for('base_blueprint.login'))



## Errors

@blueprint.errorhandler(403)
def access_forbidden(error):
    return render_template('page-403.html'), 403

@blueprint.errorhandler(404)
def not_found_error(error):
    return render_template('page-404.html'), 404

@blueprint.errorhandler(500)
def internal_error(error):
    return render_template('page-500.html'), 500

my_app/app/base/templates/accounts/login.html
{% extends "layouts/base.html" %}

{% block title %} Login {% endblock %} 

<!-- Specific Page CSS goes HERE  -->
{% block stylesheets %}{% endblock stylesheets %}

{% block content %}

<div class="page-inner">
    <div class="page-header">
        <h4 class="page-title">Login</h4>
        <ul class="breadcrumbs">
            <li class="nav-home">
                <a href="#">
                    <i class="flaticon-home"></i>
                </a>
            </li>
            <li class="separator">
                <i class="flaticon-right-arrow"></i>
            </li>
            <li class="nav-item">
                <a href="#">Authentication</a>
            </li>
            <li class="separator">
                <i class="flaticon-right-arrow"></i>
            </li>
            <li class="nav-item">
                <a href="#">Login</a>
            </li>
        </ul>
    </div>
    <div class="row">
        <div class="col-md-12">
            {%if 'identified' not in session or session['identified'] == False %}
            <div class="card">
                <div class="card-header">
                    <div class="card-title">
                        {% if msg %}
                            <span class="text-danger">{{ msg | safe }}</span>
                        {% else %}
                        <span>
                            Ingreso
                        </span>
                        {% endif %}
                    </div>
                </div>
                {% with messages = get_flashed_messages() %}
                {% if messages %}
                <ul>
                {% for message in messages %}
                    <li>{{ message }}</li>
                {% endfor %}
                </ul>
                {% endif %}
                {% endwith %}
                <form method="post" action="">
                    {{ form.hidden_tag() }}
                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-6 col-lg-4">
                                <div class="form-group">
                                    <div class="input-group mb-3">
                                        <div class="input-group-prepend">
                                            <span class="input-group-text">
                                                <i class="icon-user"></i>
                                            </span>
                                        </div>
                                        {{ form.email(placeholder="Correo electronico", class="form-control") }}
                                    </div>
                                </div>
                                <div class="form-group">
                                    <div class="input-group mb-3">
                                        <div class="input-group-prepend">
                                            <span class="input-group-text">
                                                <i class="icon-lock"></i>
                                            </span>
                                        </div>
                                        {{ form.password(placeholder="Password", class="form-control", type="password") }}
                                    </div>
                                </div>

                            </div>
                        </div>
                    </div>
                    <div class="card-action">
                        <button type="submit" name="login" class="btn btn-success">Ingresar</button>
                        &nbsp; &nbsp;
                    </div>
                </form>
            </div>
            {% endif %}
        </div>
    </div>
</div>

{% endblock content %}

<!-- Specific Page JS goes HERE  -->
{% block javascripts %}{% endblock javascripts %}

my_app/app/base/templates/includes/configuration-plugin.html
        <div class="custom-template">
            <div class="title">Settings</div>
            <div class="custom-content">
                <div class="switcher">
                    <div class="switch-block">
                        <h4>Logo Header</h4>
                        <div class="btnSwitch">
                            <button type="button" class="changeLogoHeaderColor" data-color="dark"></button>
                            <button type="button" class="selected changeLogoHeaderColor" data-color="blue"></button>
                            <button type="button" class="changeLogoHeaderColor" data-color="purple"></button>
                            <button type="button" class="changeLogoHeaderColor" data-color="light-blue"></button>
                            <button type="button" class="changeLogoHeaderColor" data-color="green"></button>
                            <button type="button" class="changeLogoHeaderColor" data-color="orange"></button>
                            <button type="button" class="changeLogoHeaderColor" data-color="red"></button>
                            <button type="button" class="changeLogoHeaderColor" data-color="white"></button>
                            <br/>
                            <button type="button" class="changeLogoHeaderColor" data-color="dark2"></button>
                            <button type="button" class="changeLogoHeaderColor" data-color="blue2"></button>
                            <button type="button" class="changeLogoHeaderColor" data-color="purple2"></button>
                            <button type="button" class="changeLogoHeaderColor" data-color="light-blue2"></button>
                            <button type="button" class="changeLogoHeaderColor" data-color="green2"></button>
                            <button type="button" class="changeLogoHeaderColor" data-color="orange2"></button>
                            <button type="button" class="changeLogoHeaderColor" data-color="red2"></button>
                        </div>
                    </div>
                    <div class="switch-block">
                        <h4>Navbar Header</h4>
                        <div class="btnSwitch">
                            <button type="button" class="changeTopBarColor" data-color="dark"></button>
                            <button type="button" class="changeTopBarColor" data-color="blue"></button>
                            <button type="button" class="changeTopBarColor" data-color="purple"></button>
                            <button type="button" class="changeTopBarColor" data-color="light-blue"></button>
                            <button type="button" class="changeTopBarColor" data-color="green"></button>
                            <button type="button" class="changeTopBarColor" data-color="orange"></button>
                            <button type="button" class="changeTopBarColor" data-color="red"></button>
                            <button type="button" class="changeTopBarColor" data-color="white"></button>
                            <br/>
                            <button type="button" class="changeTopBarColor" data-color="dark2"></button>
                            <button type="button" class="selected changeTopBarColor" data-color="blue2"></button>
                            <button type="button" class="changeTopBarColor" data-color="purple2"></button>
                            <button type="button" class="changeTopBarColor" data-color="light-blue2"></button>
                            <button type="button" class="changeTopBarColor" data-color="green2"></button>
                            <button type="button" class="changeTopBarColor" data-color="orange2"></button>
                            <button type="button" class="changeTopBarColor" data-color="red2"></button>
                        </div>
                    </div>
                    <div class="switch-block">
                        <h4>Sidebar</h4>
                        <div class="btnSwitch">
                            <button type="button" class="selected changeSideBarColor" data-color="white"></button>
                            <button type="button" class="changeSideBarColor" data-color="dark"></button>
                            <button type="button" class="changeSideBarColor" data-color="dark2"></button>
                        </div>
                    </div>
                    <div class="switch-block">
                        <h4>Background</h4>
                        <div class="btnSwitch">
                            <button type="button" class="changeBackgroundColor" data-color="bg2"></button>
                            <button type="button" class="changeBackgroundColor selected" data-color="bg1"></button>
                            <button type="button" class="changeBackgroundColor" data-color="bg3"></button>
                            <button type="button" class="changeBackgroundColor" data-color="dark"></button>
                        </div>
                    </div>
                </div>
            </div>
            <div class="custom-toggle">
                <i class="flaticon-settings"></i>
            </div>
        </div>

my_app/app/base/templates/includes/footer.html
            <footer class="footer">
            </footer>
            

my_app/app/base/templates/includes/scripts.html
    <!--   Core JS Files   -->
    <script src="/static/assets/js/core/jquery.3.2.1.min.js"></script>
    <script src="/static/assets/js/core/popper.min.js"></script>
    <script src="/static/assets/js/core/bootstrap.min.js"></script>

    <!-- jQuery UI -->
    <script src="/static/assets/js/plugin/jquery-ui-1.12.1.custom/jquery-ui.min.js"></script>
    <script src="/static/assets/js/plugin/jquery-ui-touch-punch/jquery.ui.touch-punch.min.js"></script>

    <!-- jQuery Scrollbar -->
    <script src="/static/assets/js/plugin/jquery-scrollbar/jquery.scrollbar.min.js"></script>

    <!-- Chart JS -->
<!--     <script src="/static/assets/js/plugin/chart.js/chart.min.js"></script> -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/2.5.0/Chart.min.js"></script>

    <!-- jQuery Sparkline -->
    <script src="/static/assets/js/plugin/jquery.sparkline/jquery.sparkline.min.js"></script>

    <!-- Chart Circle -->
    <script src="/static/assets/js/plugin/chart-circle/circles.min.js"></script>

    <!-- Datatables -->
    <script src="/static/assets/js/plugin/datatables/datatables.min.js"></script>

    <!-- Bootstrap Notify -->
    <script src="/static/assets/js/plugin/bootstrap-notify/bootstrap-notify.min.js"></script>

    <!-- jQuery Vector Maps -->
    <script src="/static/assets/js/plugin/jqvmap/jquery.vmap.min.js"></script>
    <script src="/static/assets/js/plugin/jqvmap/maps/jquery.vmap.world.js"></script>

    <!-- Sweet Alert -->
   <script src="/static/assets/js/plugin/sweetalert/sweetalert.min.js"></script>

    <!-- Atlantis JS -->
    <script src="/static/assets/js/atlantis.min.js"></script>

my_app/app/base/templates/includes/sidebar.html
        <!-- Sidebar -->
        <div class="sidebar sidebar-style-2" data-background-color="dark2">
            <div class="sidebar-wrapper scrollbar scrollbar-inner">
                <div class="sidebar-content">
                    {% if 'identified' in session and session['identified'] %}
                    <div class="user">
                        <div class="avatar-sm float-left mr-2">
                            <h3>Sesión</h3>
<!--                        <img src="/static/assets/img/profile.jpg" alt="..." class="avatar-img rounded-circle"> -->
                        </div>
                        <div class="info">
                            <a data-toggle="collapse" href="#collapseExample" aria-expanded="true">
                                <span>
                                    <!-- TODO show username -->
                                    <span class="user-level">
                                    <!-- TODO show email-->
                                    </span>
                                    <span class="caret"></span>
                                </span>
                            </a>
                            <div class="clearfix"></div>

                            <div class="collapse in" id="collapseExample">
                                <ul class="nav">
                                    <li>
                                        <a href="{{ url_for('base_blueprint.logout') }}">
                                            <span class="link-collapse">Terminar sesión</span>
                                        </a>
                                    </li>
                                </ul>
                            </div>
                        </div>
                    </div>
                    <ul class="nav nav-primary">
                        <li class="nav-item {% if 'index' in segment %} active {% endif %}">
                            <a data-toggle="collapse" href="#dashboard" class="collapsed" aria-expanded="false">
                                <i class="fas fa-home"></i>
                                <p>Sala de situación</p>
                                <span class="caret"></span>
                            </a>
                            <div class="collapse" id="dashboard">
                                <ul class="nav nav-collapse" id="dashboard_nav">
                                    <li>
                                        <a href="{{ url_for('home_blueprint.index')}}">
                                            <span class="sub-item">Resumen de producción</span>
                                        </a>
                                    </li>
                                    <li>
                                        <a href="{{ url_for('home_blueprint.covid_dashboard')}}">
                                            <span class="sub-item">Sala Covid</span>
                                        </a>
                                    </li>
                                </ul>
                            </div>
                        </li>
                        <li class="nav-section">
                            <span class="sidebar-mini-icon">
                                <i class="fa fa-ellipsis-h"></i>
                            </span>
                            <h4 class="text-section">Estadisticas</h4>
                        </li>
                        <li class="nav-item {% if 'patient' in segment %} active {% endif %}">
                            <a data-toggle="collapse" href="#patient" class="collapsed" aria-expanded="false">
                                <i class="fas fa-user"></i>
                                <p>Pacientes</p>
                                <span class="caret"></span>
                            </a>
                            <div class="collapse" id="patient">
                                <ul class="nav nav-collapse">
                                    <li>
                                        <a href="{{ url_for('home_blueprint.patient_population')}}">
                                            <span class="sub-item">Población</span>
                                        </a>
                                    </li>
                                    <li>
                                        <a href="{{ url_for('home_blueprint.covid_dashboard')}}">
                                            <span class="sub-item">Cobertura de salud</span>
                                        </a>
                                    </li>
                                </ul>
                            </div>
                        </li>
                    </ul>
                <!-- TODO else block                 -->
                {% else %}
                <!-- TODO endif block-->
                {% endif %}
                </div>
            </div>
        </div>
        <!-- End Sidebar -->
        

my_app/app/base/templates/layouts/base-fullscreen.html
<!-- NOT_IMPLEMENTED -->

my_app/app/base/templates/layouts/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />

    <title>
        Sala de situación - {% block title %}{% endblock %}
    </title>

    <meta content='width=device-width, initial-scale=1.0, shrink-to-fit=no' name='viewport' />
<!--    <link rel="icon" href="/static/assets/img/icon.ico" type="image/x-icon"/>-->
<!--    <link rel="canonical" href="https://appseed.us/admin-dashboards/flask-dashboard-atlantis-dark">-->

    <!-- Fonts and icons -->
    <script src="/static/assets/js/plugin/webfont/webfont.min.js"></script>
    <script>
        WebFont.load({
            google: {"families":["Lato:300,400,700,900"]},
            custom: {"families":["Flaticon", "Font Awesome 5 Solid", "Font Awesome 5 Regular", "Font Awesome 5 Brands", "simple-line-icons"], 
            urls: ['/static/assets/css/fonts.min.css']},
            active: function() {
                sessionStorage.fonts = true;
            }
        });
    </script>

    <!-- CSS Files -->
    <link rel="stylesheet" href="/static/assets/css/bootstrap.min.css">
    <link rel="stylesheet" href="/static/assets/css/atlantis.min.css">
    <link rel="stylesheet" href="/static/assets/css/custom.css">


    <!-- CSS Just for demo purpose, don't include it in your project -->
<!--    <link rel="stylesheet" href="/static/assets/css/demo.css">-->

    <!-- Specific Page CSS goes HERE  -->
    {% block stylesheets %}{% endblock stylesheets %}

</head>
<body data-background-color="dark">
    <div class="wrapper">

        {% include 'includes/navigation.html' %}

        {% include 'includes/sidebar.html' %}

        <div class="main-panel">

            {% block content %}{% endblock content %}

<!--             {% include 'includes/footer.html' %} -->

        </div>

        <!-- TODO show only if current user is authenticated -->
        {% if 'identified' in session and session['identified'] %}


            <!-- Custom template | don't include it in your project! -->
<!--            {% include 'includes/configuration-plugin.html' %}-->

        <!-- TODO endif block          -->
        {% endif %}

    </div>

    {% include 'includes/scripts.html' %}

    <!-- Specific Page JS goes HERE  -->
    {% block javascripts %}{% endblock javascripts %}

</body>
</html>